Package net.sf.saxon.expr

## Class XPathContextMinor

- java.lang.Object
- - net.sf.saxon.expr.XPathContextMinor

- All Implemented Interfaces:
    `XPathContext`
  Direct Known Subclasses:
    `XPathContextMajor`

      public class XPathContextMinor
      extends java.lang.Object
      implements XPathContext

  This class represents a minor change in the dynamic context in which an XPath expression is evaluated: a "major context" object allows all aspects of the dynamic context to change, whereas a "minor context" only allows changes to the focus and the destination for push output.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `protected static class` | `XPathContextMinor.LastValue` | Container for cached value of the last() function.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected java.lang.String` | `currentDestination` |
    `protected StackFrame` | `stackFrame` |
    `protected int` | `temporaryOutputState` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `XPathContextMinor()` | Private Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Sequence` | `evaluateLocalVariable​(int slotnumber)` | Get the value of a local variable, identified by its slot number
    `XPathContext` | `getCaller()` | Get the calling XPathContext (the next one down the stack).
    `Configuration` | `getConfiguration()` | Get the Configuration
    `Item` | `getContextItem()` | Get the context item
    `Controller` | `getController()` | Get the Controller.
    `Component` | `getCurrentComponent()` | Get the current component
    `DateTimeValue` | `getCurrentDateTime()` | Get the current date and time for this query or transformation.
    `XPathException` | `getCurrentException()` | Get the current exception (in saxon:catch)
    `GroupIterator` | `getCurrentGroupIterator()` | Get the current group iterator.
    `FocusIterator` | `getCurrentIterator()` | Get the current iterator.
    `GroupIterator` | `getCurrentMergeGroupIterator()` | Get the current merge group iterator.
    `Component.M` | `getCurrentMode()` | Get the current mode.
    `java.lang.String` | `getCurrentOutputUri()` | Get the current output URI
    `RegexIterator` | `getCurrentRegexIterator()` | Get the current regex iterator.
    `Rule` | `getCurrentTemplateRule()` | Get the current template.
    `ErrorReporter` | `getErrorReporter()` | Get the error reporter.
    `int` | `getImplicitTimezone()` | Get the implicit timezone, as a positive or negative offset from UTC in minutes.
    `int` | `getLast()` | Get the context size (the position of the last item in the current node list)
    `ParameterSet` | `getLocalParameters()` | Get the local parameters for the current template call.
    `NamePool` | `getNamePool()` | Get the Name Pool
    `StackFrame` | `getStackFrame()` | Get a reference to the local stack frame for variables.
    `Component` | `getTargetComponent​(int bindingSlot)` | Bind a component reference to a component.
    `int` | `getTemporaryOutputState()` | Ask whether the XSLT output state is "temporary" or "final"
    `XPathContextMajor.ThreadManager` | `getThreadManager()` | Get the thread manager used to process asynchronous xsl:result-document threads.
    `ParameterSet` | `getTunnelParameters()` | Get the tunnel parameters for the current template call.
    `javax.xml.transform.URIResolver` | `getURIResolver()` | Get the URI resolver.
    `boolean` | `isAtLast()` | Determine whether the context position is the same as the context size that is, whether position()=last()
    `java.util.Iterator` | `iterateStackFrames()` | Get the context stack.
    `void` | `makeStackFrameMutable()` |
    `XPathContextMajor` | `newCleanContext()` | Construct a new context without copying (used for the context in a function call)
    `XPathContextMajor` | `newContext()` | Construct a new context as a copy of another.
    `XPathContextMinor` | `newMinorContext()` | Construct a new context as a copy of another.
    `void` | `setCaller​(XPathContext caller)` | Set the calling XPathContext
    `void` | `setCurrentIterator​(FocusIterator iter)` | Set a new sequence iterator.
    `void` | `setCurrentOutputUri​(java.lang.String uri)` | Set the current output URI
    `void` | `setLocalVariable​(int slotNumber, Sequence value)` | Set the value of a local variable, identified by its slot number
    `void` | `setTemporaryOutputState​(int temporary)` | Set the XSLT output state to "temporary" or "final"
    `FocusIterator` | `trackFocus​(SequenceIterator iter)` | Create, set, and return a focus tracking iterator that wraps a supplied sequence iterator.
    `FocusIterator` | `trackFocusMultithreaded​(SequenceIterator iter)` | Create, set, and return a focus tracking iterator that wraps a supplied sequence iterator, suitable for use in a multithreaded xsl:for-each iteration
    `int` | `useLocalParameter​(StructuredQName parameterId, int slotNumber, boolean isTunnel)` | Use local parameter.
    `void` | `waitForChildThreads()` | Wait for child threads started under the control of this context to finish.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### stackFrame

          protected StackFrame stackFrame

    - #### currentDestination

          protected java.lang.String currentDestination

    - #### temporaryOutputState

          protected int temporaryOutputState

  - ### Constructor Detail

    - #### XPathContextMinor

          protected XPathContextMinor()

      Private Constructor

  - ### Method Detail

    - #### newContext

          public XPathContextMajor newContext()

      Construct a new context as a copy of another. The new context is effectively added to the top of a stack, and contains a pointer to the previous context
      Specified by:
        `newContext` in interface `XPathContext`
      Returns:
        a new context, created as a copy of this context

    - #### newMinorContext

          public XPathContextMinor newMinorContext()

      Construct a new context as a copy of another. The new context is effectively added to the top of a stack, and contains a pointer to the previous context
      Specified by:
        `newMinorContext` in interface `XPathContext`
      Returns:
        a new minor context

    - #### setCaller

          public void setCaller​(XPathContext caller)

      Set the calling XPathContext
      Specified by:
        `setCaller` in interface `XPathContext`
      Parameters:
        `caller` - the XPathContext of the calling expression

    - #### newCleanContext

          public XPathContextMajor newCleanContext()

      Construct a new context without copying (used for the context in a function call)
      Specified by:
        `newCleanContext` in interface `XPathContext`
      Returns:
        a new clean context

    - #### getLocalParameters

          public ParameterSet getLocalParameters()

      Get the local parameters for the current template call.
      Specified by:
        `getLocalParameters` in interface `XPathContext`
      Returns:
        the supplied parameters

    - #### getTunnelParameters

          public ParameterSet getTunnelParameters()

      Get the tunnel parameters for the current template call.
      Specified by:
        `getTunnelParameters` in interface `XPathContext`
      Returns:
        the supplied tunnel parameters

    - #### getController

          public final Controller getController()

      Get the Controller. May return null when running outside XSLT or XQuery
      Specified by:
        `getController` in interface `XPathContext`
      Returns:
        the controller for this query or transformation

    - #### getConfiguration

          public final Configuration getConfiguration()

      Get the Configuration
      Specified by:
        `getConfiguration` in interface `XPathContext`
      Returns:
        the Saxon configuration object

    - #### getNamePool

          public final NamePool getNamePool()

      Get the Name Pool
      Specified by:
        `getNamePool` in interface `XPathContext`
      Returns:
        the name pool

    - #### getCaller

          public final XPathContext getCaller()

      Get the calling XPathContext (the next one down the stack). This will be null if unknown, or if the bottom of the stack has been reached.
      Specified by:
        `getCaller` in interface `XPathContext`
      Returns:
        the XPathContext of the calling expression

    - #### setCurrentIterator

          public void setCurrentIterator​(FocusIterator iter)

      Set a new sequence iterator.
      Specified by:
        `setCurrentIterator` in interface `XPathContext`
      Parameters:
        `iter` - the current iterator. The context item, position, and size are determined by reference to the current iterator.

    - #### trackFocus

          public FocusIterator trackFocus​(SequenceIterator iter)

      Create, set, and return a focus tracking iterator that wraps a supplied sequence iterator.
      Specified by:
        `trackFocus` in interface `XPathContext`
      Parameters:
        `iter` - the current iterator. The context item, position, and size are determined by reference to the current iterator.

    - #### trackFocusMultithreaded

          public FocusIterator trackFocusMultithreaded​(SequenceIterator iter)

      Create, set, and return a focus tracking iterator that wraps a supplied sequence iterator, suitable for use in a multithreaded xsl:for-each iteration
      Parameters:
        `iter` - the current iterator. The context item, position, and size are determined by reference to the current iterator.

    - #### getCurrentIterator

          public final FocusIterator getCurrentIterator()

      Get the current iterator. This encapsulates the context item, context position, and context size.
      Specified by:
        `getCurrentIterator` in interface `XPathContext`
      Returns:
        the current iterator, or null if there is no current iterator (which means the context item, position, and size are undefined).

    - #### getContextItem

          public final Item getContextItem()

      Get the context item
      Specified by:
        `getContextItem` in interface `XPathContext`
      Returns:
        the context item, or null if the context item is undefined

    - #### getLast

          public final int getLast()
                            throws XPathException

      Get the context size (the position of the last item in the current node list)
      Specified by:
        `getLast` in interface `XPathContext`
      Returns:
        the context size
      Throws:
        `XPathException` - if the context position is undefined

    - #### isAtLast

          public final boolean isAtLast()
                                 throws XPathException

      Determine whether the context position is the same as the context size that is, whether position()=last()
      Specified by:
        `isAtLast` in interface `XPathContext`
      Returns:
        true if the context position is the same as the context size.
      Throws:
        `XPathException`

    - #### getURIResolver

          public javax.xml.transform.URIResolver getURIResolver()

      Get the URI resolver. This gets the local URIResolver set in the XPathContext if there is one; if not, it gets the URIResolver from the Controller (which itself defaults to the one set in the Configuration).
      Specified by:
        `getURIResolver` in interface `XPathContext`
      Returns:
        the user-supplied URI resolver if there is one, or null otherwise.
      Since:
        9.6

    - #### getErrorReporter

          public ErrorReporter getErrorReporter()

      Get the error reporter. If no ErrorReporter has been set locally, the ErrorReporter in the Controller is returned; this in turn defaults to the ErrorReporter set in the Configuration.
      Specified by:
        `getErrorReporter` in interface `XPathContext`
      Returns:
        the ErrorReporter in use.
      Since:
        9.6. Changed in 10.0 to use ErrorReporter rather than ErrorListener

    - #### getCurrentException

          public XPathException getCurrentException()

      Get the current exception (in saxon:catch)
      Specified by:
        `getCurrentException` in interface `XPathContext`
      Returns:
        the current exception, or null if there is none defined

    - #### getThreadManager

          public XPathContextMajor.ThreadManager getThreadManager()

      Get the thread manager used to process asynchronous xsl:result-document threads.
      Specified by:
        `getThreadManager` in interface `XPathContext`
      Returns:
        the current thread manager; or null if multithreading is not supported

    - #### getCurrentComponent

          public Component getCurrentComponent()

      Get the current component
      Specified by:
        `getCurrentComponent` in interface `XPathContext`

    - #### getStackFrame

          public StackFrame getStackFrame()

      Get a reference to the local stack frame for variables. Note that it's the caller's job to make a local copy of this. This is used for creating a Closure containing a retained copy of the variables for delayed evaluation.
      Specified by:
        `getStackFrame` in interface `XPathContext`
      Returns:
        array of variables.

    - #### makeStackFrameMutable

          public void makeStackFrameMutable()

    - #### evaluateLocalVariable

          public final Sequence evaluateLocalVariable​(int slotnumber)

      Get the value of a local variable, identified by its slot number
      Specified by:
        `evaluateLocalVariable` in interface `XPathContext`
      Parameters:
        `slotnumber` - the slot number allocated at compile time to the variable, which identifies its position within the local stack frame
      Returns:
        the value of the variable.

    - #### setLocalVariable

          public final void setLocalVariable​(int slotNumber,
                                             Sequence value)
                                      throws XPathException

      Set the value of a local variable, identified by its slot number
      Specified by:
        `setLocalVariable` in interface `XPathContext`
      Parameters:
        `slotNumber` - the slot number allocated at compile time to the variable, which identifies its position within the local stack frame
        `value` - the value of the variable
      Throws:
        `XPathException`

    - #### waitForChildThreads

          public void waitForChildThreads()
                                   throws XPathException

      Description copied from interface: `XPathContext`
      Wait for child threads started under the control of this context to finish. This is called at the end of the (main thread of a) transformation, and also at the end of the "try" part of a try/catch. The threads affected are those used to implement xsl:result-document instructions.
      Specified by:
        `waitForChildThreads` in interface `XPathContext`
      Throws:
        `XPathException` - if any of the child threads have failed with a dynamic error.

    - #### setTemporaryOutputState

          public void setTemporaryOutputState​(int temporary)

      Set the XSLT output state to "temporary" or "final"
      Specified by:
        `setTemporaryOutputState` in interface `XPathContext`
      Parameters:
        `temporary` - set non-zero to set temporary output state; zero to set final output state. The integer gives clues as to the reason temporary output state is being set, e.g. StandardNames.XSL_VARIABLE indicates we are evaluating a variable.

    - #### getTemporaryOutputState

          public int getTemporaryOutputState()

      Ask whether the XSLT output state is "temporary" or "final"
      Specified by:
        `getTemporaryOutputState` in interface `XPathContext`
      Returns:
        non-zero if in temporary output state (integer identifies the reason); zero if in final output state

    - #### setCurrentOutputUri

          public void setCurrentOutputUri​(java.lang.String uri)

      Set the current output URI
      Specified by:
        `setCurrentOutputUri` in interface `XPathContext`
      Parameters:
        `uri` - the current output URI, or null if in temporary output state

    - #### getCurrentOutputUri

          public java.lang.String getCurrentOutputUri()

      Get the current output URI
      Specified by:
        `getCurrentOutputUri` in interface `XPathContext`
      Returns:
        the current output URI, or null if in temporary output state

    - #### useLocalParameter

          public int useLocalParameter​(StructuredQName parameterId,
                                       int slotNumber,
                                       boolean isTunnel)
                                throws XPathException

      Use local parameter. This is called when a local xsl:param element is processed. If a parameter of the relevant name was supplied, it is bound to the xsl:param element. Otherwise the method returns false, so the xsl:param default will be evaluated
      Specified by:
        `useLocalParameter` in interface `XPathContext`
      Parameters:
        `parameterId` - Globally-unique parameter identifier
        `slotNumber` - Slot number of the parameter within the stack frame of the called template
        `isTunnel` - True if a tunnel parameter is required, else false @return ParameterSet.NOT_SUPPLIED, ParameterSet.SUPPLIED, or ParameterSet.SUPPLIED_AND_CHECKED
      Returns:
        ParameterSet.NOT_SUPPLIED, ParameterSet.SUPPLIED, or ParameterSet.SUPPLIED_AND_CHECKED
      Throws:
        `XPathException`

    - #### getCurrentMode

          public Component.M getCurrentMode()

      Get the current mode.
      Specified by:
        `getCurrentMode` in interface `XPathContext`
      Returns:
        the current mode

    - #### getCurrentTemplateRule

          public Rule getCurrentTemplateRule()

      Get the current template. This is used to support xsl:apply-imports
      Specified by:
        `getCurrentTemplateRule` in interface `XPathContext`
      Returns:
        the current template

    - #### getCurrentGroupIterator

          public GroupIterator getCurrentGroupIterator()

      Get the current group iterator. This supports the current-group() and current-grouping-key() functions in XSLT 2.0
      Specified by:
        `getCurrentGroupIterator` in interface `XPathContext`
      Returns:
        the current grouped collection

    - #### getCurrentMergeGroupIterator

          public GroupIterator getCurrentMergeGroupIterator()

      Get the current merge group iterator. This supports the current-merge-group() and current-merge-key() functions in XSLT 3.0
      Specified by:
        `getCurrentMergeGroupIterator` in interface `XPathContext`
      Returns:
        the current grouped collection

    - #### getCurrentRegexIterator

          public RegexIterator getCurrentRegexIterator()

      Get the current regex iterator. This supports the functionality of the regex-group() function in XSLT 2.0.
      Specified by:
        `getCurrentRegexIterator` in interface `XPathContext`
      Returns:
        the current regular expressions iterator

    - #### getCurrentDateTime

          public DateTimeValue getCurrentDateTime()

      Get the current date and time for this query or transformation. All calls during one transformation return the same answer.
      Specified by:
        `getCurrentDateTime` in interface `XPathContext`
      Returns:
        Get the current date and time. This will deliver the same value for repeated calls within the same transformation

    - #### getImplicitTimezone

          public final int getImplicitTimezone()

      Get the implicit timezone, as a positive or negative offset from UTC in minutes. The range is -14hours to +14hours
      Specified by:
        `getImplicitTimezone` in interface `XPathContext`
      Returns:
        the implicit timezone as an offset from UTC in minutes

    - #### iterateStackFrames

          public java.util.Iterator iterateStackFrames()

      Get the context stack. This method returns an iterator whose items are instances of `ContextStackFrame`, starting with the top-most stackframe and ending at the point the query or transformation was invoked by a calling application.
      Specified by:
        `iterateStackFrames` in interface `XPathContext`
      Returns:
        an iterator over a copy of the run-time call stack

    - #### getTargetComponent

          public Component getTargetComponent​(int bindingSlot)

      Description copied from interface: `XPathContext`
      Bind a component reference to a component. This is used for binding component references (such as function calls, global variable references, or xsl:call-template) across package boundaries. The binding is done dynamically because, in the presence of overridden components, the choice among different components with the same name depends on which package the caller is in.
      Specified by:
        `getTargetComponent` in interface `XPathContext`
      Parameters:
        `bindingSlot` - Binding slots are allocated statically to the external component references in every component: for example, in the case of a template, to all global variable references, named function calls, and named template calls within that template. The binding slot therefore identifies the name of the component that is required; and the selection of an actual component is done by selection from the binding vector of the component currently being executed
      Returns:
        the component to be invoked